//+------------------------------------------------------------------+
//|                                              File Read Write.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

//    _lopen
#define OF_READ               0
#define OF_WRITE              1
#define OF_READWRITE          2
#define OF_SHARE_COMPAT       3
#define OF_SHARE_DENY_NONE    4
#define OF_SHARE_DENY_READ    5
#define OF_SHARE_DENY_WRITE   6
#define OF_SHARE_EXCLUSIVE    7

#import "kernel32.dll"
   int _lopen  (string path, int of);
   int _lcreat (string path, int attrib);
   int _llseek (int handle, int offset, int origin);
   int _lread  (int handle, string buffer, int bytes);
   int _lwrite (int handle, string buffer, int bytes);
   int _lclose (int handle);
#import

// _lopen  : p  . p:  .
// _lcreat :   .   p:  .
// _llseek :    p . p: 
//   .
// _lread  :   p    . 
// p:   ; 0 -   .
// _lwrite :    p   . p: 
//   .
// _lclose : p  . p: 0.
//    p     
// HFILE_ERROR=-1.
 
// path   : p, p    .
// of     :  .
// attrib : 0 -   ; 1 -  ; 2 -   
// 3 - .
// handle :  .
// offset :  ,  p p .
// origin :     p p: 0 - 
// p  ; 1 -   ; 2 -    .
// buffer : p/ p.
// bytes  :   .
 
//   ( of):
// int OF_READ            =0; //     
// int OF_WRITE           =1; //     
// int OF_READWRITE       =2; //     /
// int OF_SHARE_COMPAT    =3; //      
//  .         
//    .        
// ,   HFILE_ERROR.
// int OF_SHARE_DENY_NONE =4; //       
//    /  .    
//     OF_SHARE_COMPAT,   HFILE_ERROR.
// int OF_SHARE_DENY_READ =5; //        
//     .      
//   OF_SHARE_COMPAT / OF_READ  OF_READWRITE,  
//  HFILE_ERROR.
// int OF_SHARE_DENY_WRITE=6; //  ,     .
// int OF_SHARE_EXCLUSIVE =7; //       
//       /.      
//     ( ).    
//    .
//+------------------------------------------------------------------+

extern string  path="c:\output.txt";
extern double  Lots=0.01;
extern bool    bWrite=true;
int      _OrderTicket[100];
double   _OrderSLTP[100][2];
int      _OrderCount=0;
string ss="";



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   ArrayInitialize(_OrderTicket,-1);
   ArrayInitialize(_OrderSLTP,-1);
   _OrderCount=0;
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit(){return(0);}
void start(){
   if (bWrite) WriteOrderTicket(); else ReadOrderTicket();
}

void WriteOrderTicket() {
   int i,j;
   //    
   _TicketClose();
   //    
   _TicketModify();
   //    
   _TicketOpen();

}

void _TicketClose(){
   for (int i=0;i<_OrderCount;i++) {
      if (!OrderSelect(_OrderTicket[i],SELECT_BY_TICKET))   continue;
      if (OrderCloseTime()==0)                              continue;
      int j=0;
      ss=ReadFile(path);
      while (ss!="-") {Sleep(3000);ss=ReadFile(path);j++; if (j>10) break;}
      ss=StringConcatenate(OrderSymbol(),";",
                          OrderOpenTime(),";1",
                          OrderType(),";",
                          OrderOpenPrice(),";",
                          OrderStopLoss(),";",
                          OrderTakeProfit(),";",
                          AccountNumber(),";",
                          OrderTicket(),"\t\n\n");
      _OrderTicket[i]=-1;
      _OrderSLTP[i][0]=-1;
      _OrderSLTP[i][1]=-1;
   }
   _TicketSort();
}

void _TicketModify(){
   for (int i=0;i<_OrderCount;i++) {
     if (!OrderSelect(_OrderTicket[i],SELECT_BY_TICKET,MODE_TRADES)) continue;
     if (_OrderSLTP[i][0]!=OrderStopLoss() || _OrderSLTP[i][1]!=OrderTakeProfit()) {
         int j=0;
         ss=ReadFile(path);
         while (ss!="-") {Sleep(3000);ss=ReadFile(path);j++; if (j>10) break;}
         ss=StringConcatenate(OrderSymbol(),";",
                              OrderOpenTime(),";2",
                              OrderType(),";",
                              OrderOpenPrice(),";",
                              OrderStopLoss(),";",
                              OrderTakeProfit(),";",
                              AccountNumber(),";",
                              OrderTicket(),"\t\n\n");

         _OrderSLTP[i][0]=OrderStopLoss();
         _OrderSLTP[i][1]=OrderTakeProfit();
         WriteFile (path, ss);
         Sleep(3000);

      }
   }
}

void _TicketOpen(){
   for (int i=0;i<OrdersTotal();i++) {
      if (!OrderSelect(i,SELECT_BY_POS, MODE_TRADES)) continue;
      if (_TicketFind(OrderTicket()))                  continue;
      if (OrderOpenTime()-TimeCurrent()<5*60) {
         int j=0;
         ss=ReadFile(path);
         while (ss!="-") {Sleep(3000);ss=ReadFile(path);j++; if (j>10) break;}
         ss=StringConcatenate(OrderSymbol(),";",
                           OrderOpenTime(),";0",
                           OrderType(),";",
                           OrderOpenPrice(),";",
                           OrderStopLoss(),";",
                           OrderTakeProfit(),";",
                           AccountNumber(),";",
                           OrderTicket(),"\t\n\n");
         WriteFile(path, ss);
         Sleep(3000);
      }
      int tmp=ArraySize(_OrderTicket);
      if (_OrderCount>tmp-5) {
         ArrayResize(_OrderTicket,tmp+10);
         ArrayResize(_OrderSLTP,tmp+10);
      }
      _OrderTicket[_OrderCount]=OrderTicket();
      _OrderSLTP[_OrderCount][0]=OrderStopLoss();
      _OrderSLTP[_OrderCount][1]=OrderTakeProfit();
      _OrderCount++;
   }
}

void _TicketSort(){
   int start=0, j=0;
   while(_OrderTicket[start]==-1 || start<_OrderCount) start++;
   if (start==_OrderCount) return;
   for (int i=start;i<_OrderCount;i++){
      if (_OrderTicket[i]!=-1) {
         _OrderTicket[j]=_OrderTicket[i];
         _OrderSLTP[j][0]=_OrderSLTP[i][0];
         _OrderSLTP[j][1]=_OrderSLTP[i][1];
         j++;
      }
   }
   _OrderCount=j;
}

bool _TicketFind(int Ticket){for (int i=0;i<_OrderCount;i++) if (Ticket==_OrderTicket[i]) return(true);return(false);}

//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
string ReadFile (string path)  {
   int handle=_lopen (path,OF_READ);           
   if(handle<0) { Print("   ",path); return (""); }
   int result=_llseek (handle,0,0);      
   
   if(result<0) { Print("  " );  return (""); }
   
   string buffer="";
   string char1="x";
   int count=0;
   result=_lread (handle,char1,1);
   
   while(result>0)  {
      buffer=buffer+char1;
      char1="x";
      count++;
      result=_lread (handle,char1,1);
   }
   result=_lclose (handle);              
   if(result<0)  Print("   ",path);
   return (buffer);
}
void ReadOrderTicket() {
   string ss=ReadFile (path);
   if (ss=="-") return;

   // OrderSymbol()
   int i0=0; int i1=StringFind(ss,";",i0);
   string _OrderSymbol=StringSubstr(ss,i0,i1-i0);

   // OrderOpenTime()
   i0=i1+1; i1=StringFind(ss,";",i0);
   int _OrderTime=StrToInteger(StringSubstr(ss,i0,i1-i0));

   // OrderType()
   i0=i1+1; i1=StringFind(ss,";",i0);
   int _OrderType=StrToInteger(StringSubstr(ss,i0,i1-i0));

   // OrderOpenPrice()
   i0=i1+1; i1=StringFind(ss,";",i0);
   double _OrderOpenPrice= StrToDouble(StringSubstr(ss,i0,i1-i0));

   // OrderStopLoss()
   i0=i1+1; i1=StringFind(ss,";",i0);
   double _OrderStopLoss=  StrToDouble(StringSubstr(ss,i0,i1-i0));

   // OrderTakeProfit()
   i0=i1+1; i1=StringFind(ss,";",i0);
   double _OrderTakeProfit=StrToDouble(StringSubstr(ss,i0,i1-i0));

   // AccountNumber()
   i0=i1+1; i1=StringFind(ss,";",i0);
   string _AccountNumber=StringSubstr(ss,i0,i1-i0);

   // OrderTicket()
   i0=i1+1; 
   int _OrderTicket=StrToInteger(StringSubstr(ss,i0));

   WriteFile(path,"- \t\n\n");
   if (_OrderType<10) {
      OpenOrder(_OrderSymbol,_OrderType-10, _OrderOpenPrice, _OrderStopLoss, _OrderTakeProfit, _OrderTicket, _AccountNumber);
      return(0);
   }
   if (_OrderType<20) {
      CloseOrder(_OrderTicket);
      return(0);
   }
   ModifyOrder(_OrderSymbol, _OrderStopLoss, _OrderTakeProfit, _OrderTicket);
   
}

void ModifyOrder(string _OrderSymbol, double _OrderStopLoss, double _OrderTakeProfit, int Magic){
   int err=GetLastError();
   for (int i=0;i<OrdersTotal();i++) {
      if (!OrderSelect(i,SELECT_BY_POS))  continue;
      if (OrderSymbol()!=_OrderSymbol)    continue;
      if (OrderMagicNumber()!=Magic)      continue;
      
      OrderModify(OrderTicket(),OrderOpenPrice(),_OrderStopLoss,_OrderTakeProfit,0);   
   }   
}


void OpenOrder(string _OrderSymbol, int OP, double _OrderOpenPrice, double _OrderStopLoss, double _OrderTakeProfit, int Magic, string _Comment){
   int err=GetLastError();
   double tp,sl, Price;   
   double _Point  =MarketInfo(_OrderSymbol,MODE_POINT);
   err=GetLastError();
   
   if (OP==0) {
      Price   =MarketInfo(_OrderSymbol,MODE_ASK);
   } else {   
      Price=MarketInfo(_OrderSymbol,MODE_BID);
   }
   if (!CheckMagic(Magic)) OrderSend(_OrderSymbol,OP,Lots,Price,5,_OrderStopLoss,_OrderTakeProfit,_Comment,Magic,0,CLR_NONE);
}

void CloseOrder(int Magic){
   for (int i=0;i<OrdersTotal();i++){
      if (!OrderSelect(i,SELECT_BY_POS))  continue;
      if (OrderMagicNumber()!=Magic)      continue;
      OrderClose(i,OrderLots(),OrderClosePrice(),5);
   }
}

bool CheckMagic(int Magic){
   bool Res=false;
   for (int i=0;i<OrdersTotal();i++){
      if (!OrderSelect(i,SELECT_BY_POS))  continue;
      if (OrderMagicNumber()!=Magic)      continue;
      Res=True;
      break;
   }
   for (i=0;i<OrdersHistoryTotal();i++){
      if (!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))  continue;
      if (OrderMagicNumber()!=Magic)      continue;
      Res=True;
      break;
   }
   return(Res);
}

 
//+------------------------------------------------------------------+
//|                          |
//+------------------------------------------------------------------+
void WriteFile (string path, string buffer) {
   int count=StringLen (buffer); 
   int result;
   int handle=_lopen (path,OF_WRITE);
   if(handle<0)  {
      handle=_lcreat (path,0);
      if(handle<0) { Print ("   ",path); return; }
      result=_lclose (handle);
   }
   handle=_lopen (path,OF_WRITE);               
   if(handle<0)  { Print("   ",path);  return; }
   result=_llseek (handle,0,0);          
   if(result<0)  { Print("  ");  return; }
   result=_lwrite (handle,buffer,count); 
   if(result<0)   Print("    ",path," ",count," ");
   result=_lclose (handle);              
   if(result<0)   Print("   ",path);
}

